module NxtHerokuDatabaseBackup
  class Encrypter
    include NxtInit

    attr_init :pass_phrase, :salt, :data

    def call
      encrypted = encrypter.update(data)
      encrypted << encrypter.final
    end

    private

    def encrypter
      @encrypter ||= begin
        encrypter = OpenSSL::Cipher.new 'AES-128-CBC'
        encrypter.encrypt
        encrypter.pkcs5_keyivgen pass_phrase, salt
        encrypter
      end
    end
  end
end
